// Seed.cpp : Implementation of CSeed
#include "stdafx.h"
#include "ECPlazaSeed.h"
#include "Seed.h"
#include "SeedEncDec.h"
#include "CBase64.h"

#define SEED_BLK_LEN                  16


/////////////////////////////////////////////////////////////////////////////
// CSeed

STDMETHODIMP CSeed::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISeed
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (::ATL::InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CSeed::Encrypt(BSTR plainText, BSTR key, BSTR *ret)
{
	// TODO: ⿡  ڵ带 ߰մϴ.

	CSeedEncDec seed;
	CBase64 b64;
	char* pB64Output;

	char *pInput;
	char *pKey;
	USES_CONVERSION;
	pInput = OLE2A(plainText);
	pKey = OLE2A(key);

	if (strlen(pKey) != SEED_BLK_LEN) {
		return E_INVALIDARG;
	}

	int nLen = strlen(pInput);
	int nPadding = SEED_BLK_LEN - nLen % SEED_BLK_LEN; 
	int nNewLen = nLen + nPadding;

	
	BYTE *pBuf;

	pBuf = new BYTE[nNewLen+1];

	//Ansi X.923 padding
	//0x00 paddingϰ  Ʈ padding 
	memset(pBuf, 0x00, nNewLen);
	memcpy(pBuf, pInput, nLen);
	*(pBuf + nNewLen - 1) = (BYTE)nPadding;

	seed.MFK(pKey);
	seed.SE((PBYTE)pBuf, nNewLen);

	b64.CreateMatchingEncodingBuffer(nNewLen, &pB64Output);
	b64.EncodeBuffer((char *)pBuf, nNewLen, pB64Output);


	CComBSTR a(pB64Output);
	*ret = a.Detach();

	delete pBuf;
	delete pB64Output;

	return S_OK;
}

STDMETHODIMP CSeed::Decrypt(BSTR cipherText, BSTR key, BSTR *ret)
{
	// TODO: ⿡  ڵ带 ߰մϴ.

	CSeedEncDec seed;
	CBase64 b64;
	char* pDecodedDataBuffer;

	char *pInput;
	char *pKey;
	USES_CONVERSION;
	pInput = OLE2A(cipherText);
	pKey = OLE2A(key);

	if (strlen(pKey) != SEED_BLK_LEN) {
		return E_INVALIDARG;
	}


	b64.CreateMatchingDecodingBuffer(pInput, &pDecodedDataBuffer);
	int nLen = b64.DecodeBuffer(pInput, pDecodedDataBuffer);


	seed.MFK(pKey);
	seed.SD((PBYTE)pDecodedDataBuffer, nLen);

	//Ansi X.923 padding removal
	BOOL isPadding = false;
	int nLastValue = *(pDecodedDataBuffer + nLen - 1);
	if (nLastValue < SEED_BLK_LEN - 1) {
		int zeroPaddingCount = nLastValue - 1;
		for(int i=2;i<(zeroPaddingCount + 2);i++) {
			if(pDecodedDataBuffer[nLen - i] != 0x00) {
				isPadding = false;
				break;
			}
		}

		isPadding = true;
	} else {
		isPadding = false;
	}

	if (isPadding) {
		pDecodedDataBuffer[nLen - nLastValue] = '\0';
	}

	CComBSTR a((LPCSTR)pDecodedDataBuffer);
	*ret = a.Detach();

	delete pDecodedDataBuffer;
	
	return S_OK;
}

