	
// Seed.h : Declaration of the CSeed

#ifndef __SEED_H_
#define __SEED_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CSeed
class ATL_NO_VTABLE CSeed : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSeed, &CLSID_Seed>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISeed, &IID_ISeed, &LIBID_ECPLAZASEEDLib>
{
public:
	CSeed()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SEED)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSeed)
	COM_INTERFACE_ENTRY(ISeed)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ISeed
public:
	STDMETHOD(Decrypt)(/*[in]*/ BSTR cipherText, /*[in]*/ BSTR key, /*[out, retval]*/BSTR *ret);
	STDMETHOD(Encrypt)(/*[in]*/ BSTR plainText, /*[in]*/ BSTR key, /*[out, retval]*/BSTR *ret);

};

#endif //__SEED_H_
